
import { world, system } from "@minecraft/server";

function wait(ticks) {
    return new Promise(resolve => system.runTimeout(resolve, ticks));
}

world.beforeEvents.itemUse.subscribe(async data => {
    const player = data.source;
    if (!player || data.itemStack.typeId !== "kittysbuild:texspawn") return;

    for (const player of world.getPlayers()) {
        await player.runCommandAsync(`playsound note.pling @s ~ ~ ~`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.legs 0 air`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.feet 0 air`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.chest 0 air`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.head 0 air`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.weapon.mainhand 0 air`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.weapon.offhand 0 air`);
        await player.runCommandAsync(`kill @e[type=armor_stand,tag="Kittys Build Bot"]`);
        await player.runCommandAsync(`setblock ~ ~ ~1 sea_lantern`);
        await player.runCommandAsync(`setblock ~1 ~ ~ sea_lantern`);
        await player.runCommandAsync(`setblock ~ ~-1 ~ sea_lantern`);
        await player.runCommandAsync(`setblock ~-1 ~ ~ sea_lantern`);
        await player.runCommandAsync(`setblock ~ ~ ~-1 sea_lantern`);
        await player.runCommandAsync(`summon armor_stand "§dKittys Build Bot" ~ ~ ~ `);
        await player.runCommandAsync(`tag @e[type=armor_stand,name="§dKittys Build Bot"] add "Kittys Build Bot"`);
        for (const entity of world.getDimension('overworld').getEntities({ type: "minecraft:armor_stand", tags: ["Kittys Build Bot"] })) {
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say Loading: §c17 §fBuild Parts`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.legs 0 diamond_leggings`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.feet 0 diamond_boots`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.chest 0 diamond_chestplate`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.armor.head 0 diamond_helmet`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.weapon.mainhand 0 diamond_sword`);
        await player.runCommandAsync(`replaceitem entity @e[tag="Kittys Build Bot"] slot.weapon.offhand 0 shield`);

        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§61§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part1`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§62§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part2`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§63§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part3`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§64§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part4`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§65§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part5`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§66§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part6`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§67§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part7`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§68§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part8`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§69§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part9`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§610§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part10`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§611§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part11`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§612§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part12`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§613§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part13`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§614§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part14`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§615§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part15`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§616§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part16`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        entity.nameTag = "§dKittys Build Bot\n§bLoading Part: [§617§b/§c17§b]\nMay Cause Lag During Spawn";
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ function TexSpawn_part17`);
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say !!`);
        await wait(25);
        
        await player.runCommandAsync(`execute @e[type=armor_stand,tag="Kittys Build Bot"] ~~~ say §6Build Completed! Be Sure To Check The Far Side Of The Build Fully Spawned`);
        await player.runCommandAsync(`playsound note.pling @s ~ ~ ~`);
        entity.nameTag = "§dKittys Build Bot\n§6Build Completed!\n§bBe Sure To Check The Far Side Of The Build Fully Spawned!!\nSupport Server:\nhttps://discord.gg/aujyATgMVy";
    }}
});
